<?php
$livello="../";
$elenco_auth = array('superuser');
include($livello."includes/auth.php");
?>

<?php 
$_SESSION['section']="Amministrazione Piattaforma";
include($livello."struct/open.php");
include($livello."includes/function.php");
include($livello."includes/formdata.php");
include($livello."includes/jalfa_pass.php");
include($livello."includes/ini.php");
include($livello."includes/snoopy/Snoopy.class.php")
?>
<?php 
    include ($livello.'struct/menu_main.php');
?>
<h1><?php echo $_SESSION["section"];?></h1>
<div class="row">
<div class="col-12"> 

<?php 

$GLOBALS['status'] = array();
/**
 * Class Unzipper
 */
class Unzipper {
    public $localdir = '.';
    public $zipfiles = array();
    
    public function __construct() {
        // Read directory and pick .zip, .rar and .gz files.
        if ($dh = opendir($this->localdir)) {
            while (($file = readdir($dh)) !== FALSE) {
                if (pathinfo($file, PATHINFO_EXTENSION) === 'zip'
                    || pathinfo($file, PATHINFO_EXTENSION) === 'gz'
                    || pathinfo($file, PATHINFO_EXTENSION) === 'rar'
                    ) {
                        $this->zipfiles[] = $file;
                    }
            }
            closedir($dh);
            
            if (!empty($this->zipfiles)) {
                $GLOBALS['status'] = array('info' => '.zip or .gz or .rar files found, ready for extraction');
            }
            else {
                $GLOBALS['status'] = array('info' => 'No .zip or .gz or rar files found. So only zipping functionality available.');
            }
        }
    }
    
    /**
     * Prepare and check zipfile for extraction.
     *
     * @param string $archive
     *   The archive name including file extension. E.g. my_archive.zip.
     * @param string $destination
     *   The relative destination path where to extract files.
     */
    public function prepareExtraction($archive, $destination = '') {
        // Determine paths.
        if (empty($destination)) {
            $extpath = $this->localdir;
        }
        else {
            $extpath = $this->localdir . '/' . $destination;
            // Todo: move this to extraction function.
            if (!is_dir($extpath)) {
                mkdir($extpath);
            }
        }
        // Only local existing archives are allowed to be extracted.
        if (in_array($archive, $this->zipfiles)) {
            self::extract($archive, $extpath);
        }
    }
    
    /**
     * Checks file extension and calls suitable extractor functions.
     *
     * @param string $archive
     *   The archive name including file extension. E.g. my_archive.zip.
     * @param string $destination
     *   The relative destination path where to extract files.
     */
    public static function extract($archive, $destination) {
        $ext = pathinfo($archive, PATHINFO_EXTENSION);
        switch ($ext) {
            case 'zip':
                self::extractZipArchive($archive, $destination);
                break;
            case 'gz':
                self::extractGzipFile($archive, $destination);
                break;
            case 'rar':
                self::extractRarArchive($archive, $destination);
                break;
        }
        
    }
    
    /**
     * Decompress/extract a zip archive using ZipArchive.
     *
     * @param $archive
     * @param $destination
     */
    public static function extractZipArchive($archive, $destination) {
        // Check if webserver supports unzipping.
        if (!class_exists('ZipArchive')) {
            $GLOBALS['status'] = array('error' => 'Error: Your PHP version does not support unzip functionality.');
            return;
        }
        
        $zip = new ZipArchive;
        
        // Check if archive is readable.
        if ($zip->open($archive) === TRUE) {
            // Check if destination is writable
            if (is_writeable($destination . '/')) {
                $zip->extractTo($destination);
                $zip->close();
                $GLOBALS['status'] = array('success' => 'Files unzipped successfully');
            }
            else {
                $GLOBALS['status'] = array('error' => 'Error: Directory not writeable by webserver.');
            }
        }
        else {
            $GLOBALS['status'] = array('error' => 'Error: Cannot read .zip archive.');
        }
    }
    
    /**
     * Decompress a .gz File.
     *
     * @param string $archive
     *   The archive name including file extension. E.g. my_archive.zip.
     * @param string $destination
     *   The relative destination path where to extract files.
     */
    public static function extractGzipFile($archive, $destination) {
        // Check if zlib is enabled
        if (!function_exists('gzopen')) {
            $GLOBALS['status'] = array('error' => 'Error: Your PHP has no zlib support enabled.');
            return;
        }
        
        $filename = pathinfo($archive, PATHINFO_FILENAME);
        $gzipped = gzopen($archive, "rb");
        $file = fopen($destination . '/' . $filename, "w");
        
        while ($string = gzread($gzipped, 4096)) {
            fwrite($file, $string, strlen($string));
        }
        gzclose($gzipped);
        fclose($file);
        
        // Check if file was extracted.
        if (file_exists($destination . '/' . $filename)) {
            $GLOBALS['status'] = array('success' => 'File unzipped successfully.');
            
            // If we had a tar.gz file, let's extract that tar file.
            if (pathinfo($destination . '/' . $filename, PATHINFO_EXTENSION) == 'tar') {
                $phar = new PharData($destination . '/' . $filename);
                if ($phar->extractTo($destination)) {
                    $GLOBALS['status'] = array('success' => 'Extracted tar.gz archive successfully.');
                    // Delete .tar.
                    unlink($destination . '/' . $filename);
                }
            }
        }
        else {
            $GLOBALS['status'] = array('error' => 'Error unzipping file.');
        }
        
    }
    
    /**
     * Decompress/extract a Rar archive using RarArchive.
     *
     * @param string $archive
     *   The archive name including file extension. E.g. my_archive.zip.
     * @param string $destination
     *   The relative destination path where to extract files.
     */
    public static function extractRarArchive($archive, $destination) {
        // Check if webserver supports unzipping.
        if (!class_exists('RarArchive')) {
            $GLOBALS['status'] = array('error' => 'Error: Your PHP version does not support .rar archive functionality. <a class="info" href="http://php.net/manual/en/rar.installation.php" target="_blank">How to install RarArchive</a>');
            return;
        }
        // Check if archive is readable.
        if ($rar = RarArchive::open($archive)) {
            // Check if destination is writable
            if (is_writeable($destination . '/')) {
                $entries = $rar->getEntries();
                foreach ($entries as $entry) {
                    $entry->extract($destination);
                }
                $rar->close();
                $GLOBALS['status'] = array('success' => 'Files extracted successfully.');
            }
            else {
                $GLOBALS['status'] = array('error' => 'Error: Directory not writeable by webserver.');
            }
        }
        else {
            $GLOBALS['status'] = array('error' => 'Error: Cannot read .rar archive.');
        }
    }
    
}




?>
<?php 
function dir_is_empty($dir) {
    $handle = opendir($dir);
    while (false !== ($entry = readdir($handle))) {
        if ($entry != "." && $entry != "..") {
            closedir($handle);
            return false;
        }
    }
    closedir($handle);
    return true;
}
?>
<?php 
function download_upgrade_zip($date_zip){
    $url = 'https://www.officinescuola.it/schoolcom/deployment/zip/'.$date_zip;
    $ch = curl_init($url);
    $file_name = basename($url);
    $save_file_loc = $file_name;
    $fp = fopen($save_file_loc, 'wb');
    curl_setopt($ch, CURLOPT_FILE, $fp);
    curl_setopt($ch, CURLOPT_HEADER, 0);
    curl_exec($ch);
    curl_close($ch);
    fclose($fp);
}

?>
      
<?php
    $utente=$_SESSION['utente'];
    if ($_SERVER["REQUEST_METHOD"]=='POST'){
        $agg = $_POST["agg"];
        $ver = $_POST["ver"];
        $dev = $_POST["dev"];
        $snoopy1 = new Snoopy;
        $url = "https://www.officinescuola.it/schoolcom/deployment/get_up_id.php?ver=".$ver."&d=".$dev."&agg=".$agg;
        //echo $url.'<br>';
        $snoopy1->fetchtext($url);
        $result = $snoopy1->results;
        $download = explode(',', $result);
        $zip_file = $download[2].'.zip';
        download_upgrade_zip($zip_file);
        $unzipper = new Unzipper;
        $unzipper->prepareExtraction($zip_file, $download[2]);
        if (file_exists($zip_file)){unlink($zip_file);}  
        // consultazione db aggiornamenti per set di pari data
        $id_ini = $download[0];
        $id_fin = $download[1];
        $msg_agg = '';
        for($id=$id_ini;$id<=$id_fin;$id++){
            $id_agg = trim($id);
            $snoopy2 = new Snoopy;
            $url2 = "https://www.officinescuola.it/schoolcom/deployment/upgrade_http.php?agg=".trim($id)."&d=".$dev;
            //echo $url2.'<br>';
            $snoopy2->fetchtext($url2);
            $data =  $snoopy2->results;
            //echo '<br>'.$data.'<br>';
            if (trim($data)!='false'){
                $down = explode(',',$data);
                //array che contiene: [0]=path; [1]: nome del file; [2]: azione
                switch ($down[2]){
                    case "add":
                        $newfile = '../'.trim($down[0]).'/'.trim($down[1]);
                        $downfile = $download[2].'/'.$down[1];
                        if (rename ($downfile, $newfile)){
                            $msg = "Upgrade $id_agg: Aggiornato il file ".trim($down[0])."/".trim($down[1]);
                            echo $msg."<br>";
                            $msg_agg.= $msg;
                            $data_agg=date('Y-m-d H:i:s');
                            $sql = "UPDATE generalinfo SET aggiornamenti='$id_agg',data_aggiornamenti='$data_agg' WHERE 1";
                            mysqli_query($conn,$sql) or dies($conn);  
                        }
                        break;
                    case "mkd":
                        $file_path = "../".trim($down[0])."/".trim($down[1]);
                        if(mkdir($file_path, 0755, true)){
                            $msg = "Upgrade $id_agg: Aggiunta la cartella ".trim($down[0])."/".trim($down[1]);
                            echo $msg."<br>";
                            $msg_agg.= $msg;
                            $data_agg=date('Y-m-d H:i:s');
                            $sql = "UPDATE generalinfo SET aggiornamenti='$id_agg',data_aggiornamenti='$data_agg' WHERE 1";
                            mysqli_query($conn,$sql) or dies($conn);
                        }
                        break;
                    case "del":
                        $file_path = "../".trim($down[0])."/".trim($down[1]);
                        if (file_exists($file_path)){
                            if (unlink($file_path)){
                                $msg = "Upgrade $id_agg: Eliminato il file ".trim($down[0])."/".trim($down[1]);
                                echo $msg."<br>";
                                $msg_agg.= $msg;
                                $data_agg=date('Y-m-d H:i:s');
                                $sql = "UPDATE generalinfo SET aggiornamenti='$id_agg' ,data_aggiornamenti='$data_agg' WHERE 1";
                                mysqli_query($conn,$sql) or dies($conn);
                            }
                        }
                        else { echo 'errore: il file '.$file_path.' non esiste <br />';
                            $data_agg=date('Y-m-d H:i:s');
                            $sql = "UPDATE generalinfo SET aggiornamenti='$id_agg' ,data_aggiornamenti='$data_agg' WHERE 1";
                            mysqli_query($conn,$sql) or dies($conn);
                        }
                        break;
                    case "sql":
                        $file_sql = $download[2].'/'.$down[1];
                        $fp = fopen( $file_sql, "r" );
                            $linea = "";
                            $query = "";
                            while (!feof( $fp ) ){
                                $linea = fgets( $fp, 4096 );
                                $cut=substr($linea, -5);
                                if (strpos( $cut, ';' ) ) {
                                    $query = $query . " " . $linea;
                                    $sql = "SET NAMES 'utf8'";
                                    mysqli_query($conn,$sql);
                                    $result = mysqli_query($conn,$query );
                                    if ($result==FALSE) {
                                        dies('Query non valida');
                                    }
                                    $query = "";
                                }
                                else {
                                    $query = $query . " " . $linea;
                                }
                            
                            }
                            fclose($fp);
                            unlink($file_sql);
                            $msg = "Upgrade $id_agg: Aggiornato il database di schoolcom ";
                            echo $msg.'<br>';
                            $msg_agg.= $msg;
                            $data_agg=date('Y-m-d H:i:s');
                            $sql = "UPDATE generalinfo SET aggiornamenti='$id_agg',data_aggiornamenti='$data_agg' WHERE 1";
                            mysqli_query($conn,$sql) or dies($conn);
                }
            }
            else {   
            }
            }
            if ($msg_agg!=''){
                $msg_agg = $data_agg.'\n'.$msg_agg;
                $sql = "UPDATE generalinfo SET msg_aggiornamenti='$msg_agg' WHERE 1";
                mysqli_query($conn,$sql) or dies($conn);
                if(dir_is_empty($download[2])){rmdir($download[2]);}
                }
            echo '<div class="alert alert-success" role="alert">Ciclo di aggiornamento concluso! <br><a href="aggiornamenti.php">Controlla se ci sono nuovi aggiornamenti</a></div>';
            // fine consultazione db aggiornamenti
    }
    else{
    	$sql = "SELECT versione, aggiornamenti,development FROM generalinfo WHERE 1";
    	$ris = mysqli_query($conn,$sql) or dies($conn);
    	$rec = mysqli_fetch_array($ris);
    	$agg = $rec['aggiornamenti'];
    	$ver = $rec["versione"];
    	$w = $_SESSION["top"];
    	$d = $rec["development"];
    	$snoopy1 = new Snoopy;
    	$check_url = "https://www.officinescuola.it/schoolcom/deployment/check_aggiornamenti.php?ver=".$ver."&a=".$agg."&w=".$w;
    	$snoopy1->fetchtext($check_url);
    	$url = "https://www.officinescuola.it/schoolcom/deployment/query_max.php?ver=".$ver."&d=".$d;
    	$snoopy1->fetchtext($url);
    	$agg_schoolcom = $snoopy1->results;
    	if ($agg_schoolcom =='false' || $agg>=$agg_schoolcom){
    		echo '<div class="alert alert-success" role="alert"><p>Il sistema  &egrave; aggiornato</p>
                    <p>Versione: '.$ver.' </p>
                    <p>Progressivo aggiornamenti: '.$agg.'</p></div>';
    		}
    		else {
    		    echo '<div class="alert alert-info" role="alert"><p>Ci sono degli aggiornamenti disponibili</p></div>';
            		echo '<p>Clicca sul pulsante per aggiornare il sistema</p>
            		<form name="form1" id="form1" action="'.$_SERVER["PHP_SELF"].'" method="POST">
                    <input type="hidden" name="agg" value="'.$agg.'">
                    <input type="hidden" name="ver" value="'.$ver.'">
                    <input type="hidden" name="dev" value="'.$d.'">
            		<button type="submit" onClick="return confirm('."'Sei sicuro di voler aggiornare il sistema?  Questa operazione non &egrave; annullabile'".')">Aggiorna il sistema</button> 
            		</form>';
    	}
    }
 ?> 
</div>
</div>
<?php include($livello."struct/close.php"); ?>
